(
(
( CPU specific words
(
(


ONLY CROSS ALSO DEFINITIONS

__( Building Assembler primitives )
: R<>D
   EC87 T_LIT WASINSTR IF
      -2 T_LIT ALLOT CLROPT
   ELSE
      EC87 T_LIT I,
   ENDIF ;
: RET       00C3 T_LIT IC, ;
: RETF      00CB T_LIT IC, ;
: LIT       0053 T_LIT IC, ( PUSH_BX ) 00BB T_LIT C, , ( MOV_BX,# ) ;
: COMPILE,  R<>D 00E8 T_LIT IC, HERE RELOC - 2- , R<>D ;

: ADD_BX,AX       D803 T_LIT I, ;
: ADD_[BX],AX     0701 T_LIT I, ;
: ADD_BP,#        C583 T_LIT I, C, ;
: ADD_CX,BX       CB03 T_LIT I, ;

: AND_BX,AX       D823 T_LIT I, ;

: CALL_AX         D0FF T_LIT I, ;
: CALL_#          00E8 T_LIT IC, HERE - 2- , ;
: CMP_BX,AX       D83B T_LIT I, ;
: CMP_CX,DX       CA3B T_LIT I, ;

: DEC_BX          004B T_LIT IC, ;

: FIXFWD          DUP 0<> IF HERE OVER - 2- SWAP !
                  ELSE DROP ENDIF CLROPT ; ( See also JMPFWD )

: INC_BX          0043 T_LIT IC, ;
: INC_CX          0041 T_LIT IC, ;

: INT_#           00CD T_LIT IC, C, ;

: JE              0074 T_LIT IC, ;
: JG              007F T_LIT IC, ;
: JGE             007D T_LIT IC, ;
: JL              007C T_LIT IC, ;
: JLE             007E T_LIT IC, ;
: JNE             0075 T_LIT IC, ;
: JMP_#           00E9 T_LIT IC, HERE - 2- , ;
: JMPFWD          00E9 T_LIT IC, HERE 0 T_LIT , ;

: MOV_AX,BX       C38B T_LIT I, ;
: MOV_AX,SP       C48B T_LIT I, ;
: MOV_AX,#        00B8 T_LIT IC, , ;
: MOV_BX,AX       D88B T_LIT I, ;
: MOV_BX,CX       D98B T_LIT I, ;
: MOV_BX,DX       DA8B T_LIT I, ;
: MOV_BX,[BX]     1F8B T_LIT I, ;
: MOV_BX,#[BP]    5E8B T_LIT I, C, ;
: MOV_BX,#        00BB T_LIT IC, , ;
: MOV_BL,[BX]     1F8A T_LIT I, ;
: MOV_BH,#        00B7 T_LIT IC, C, ;
: MOV_[BX],AL     0788 T_LIT I, ;
: MOV_[BX],AX     0789 T_LIT I, ;
: MOV_[BX],BP     2F89 T_LIT I, ;
: MOV_[BX],SP     2789 T_LIT I, ;
: MOV_BP,[BX]     2F8B T_LIT I, ;
: MOV_CX,BX       CB8B T_LIT I, ;
: MOV_DX,BX       D38B T_LIT I, ;
: MOV_DX,#[BP]    568B T_LIT I, C, ;
: MOV_SP,[BX]     278B T_LIT I, ;

: NEG_BX          DBF7 T_LIT I, ;

: OR_BX,AX        D80B T_LIT I, ;

: POP_AX          0058 T_LIT IC, ;
: POP_BX          005B T_LIT IC, ;
: POP_CX          0059 T_LIT IC, ;
: POP_DX          005A T_LIT IC, ;
: PUSH_AX         0050 T_LIT IC, ;
: PUSH_BX         0053 T_LIT IC, ;
: PUSH_CX         0051 T_LIT IC, ;
: PUSH_DX         0052 T_LIT IC, ;

: SAR_BX,1        FBD1 T_LIT I, ;
: SBB_BX,BX       DB1B T_LIT I, ;
: SUB_BX,AX       D82B T_LIT I, ;
: SUB_BX,#        EB83 T_LIT I, C, ;
: SUB_DX,DX       D22B T_LIT I, ;

( : TEST_BX,BX      DB1B T_LIT WASINSTR
(                      NIF DB85 T_LIT I,
(                   ENDIF ;
: TEST_BX,BX      DB85 T_LIT I, ;

: XCHG_AX,BX      0093 T_LIT IC, ;
: XCHG_#[BP],AX   4687 T_LIT I, C, ;
: XCHG_#[BP],BX   5E87 T_LIT I, C, ;



( Primitive keywords which are to large to inline )
: U/MOD       T_POP_AX T_SUB_DX,DX T_DIV_BX
              T_PUSH_DX T_MOV_BX,AX ;
: UM/MOD      T_POP_DX T_POP_AX T_DIV_BX T_PUSH_DX
              T_MOV_BX,AX ;
: ROT         T_POP_DX T_POP_AX T_PUSH_DX
              T_XCHG_AX,BX T_PUSH_AX ;
: -ROT        T_POP_DX T_POP_AX T_PUSH_BX
              T_MOV_BX,DX T_PUSH_AX ;
: 3DROP       T_POP_BX T_POP_BX T_POP_BX ;
: 3DUP        T_POP_AX T_POP_DX T_PUSH_DX
              T_PUSH_AX T_PUSH_BX T_PUSH_DX T_PUSH_AX ;


ONLY CROSS ALSO TARGET DEFINITIONS

__( Building loop and branch primitives )
: BEGIN ( -- oldfixup a1 )
   FIXUP @ 0 T_LIT FIXUP ! HERE
   CLROPT ; IMMEDIATE
: WHILE ( a1 -- afix a1 )
   TEST_BX,BX POP_BX
   JNE 3 T_LIT C, JMPFWD SWAP
   1 T_LIT FIXUP +! ; IMMEDIATE
: UNTIL ( oldfixup .. afix a1 -- )
   TEST_BX,BX POP_BX
   JNE 3 T_LIT C, JMP_#
   FIXUP @ 0 T_LIT 2DUP <> IF
      DO FIXFWD LOOP
   ELSE 2DROP
   ENDIF FIXUP ! CLROPT ; IMMEDIATE
: REPEAT ( oldfixup .. afix a1 -- )
   JMP_#
   FIXUP @ 0 T_LIT 2DUP <> IF
      DO FIXFWD LOOP
   ELSE 2DROP
   ENDIF FIXUP ! CLROPT ; IMMEDIATE
: IF ( -- afix )
   TEST_BX,BX POP_BX
   JNE 3 T_LIT C, JMPFWD
   CLROPT ; IMMEDIATE
: NIF ( -- afix )
   TEST_BX,BX POP_BX
   JE 3 T_LIT C, JMPFWD
   CLROPT ; IMMEDIATE
: ELSE ( afix -- afix )
   JMPFWD SWAP FIXFWD
   CLROPT ; IMMEDIATE
: ENDIF ( afix -- )
   FIXFWD
   CLROPT ; IMMEDIATE

: DO ( Compile: -- afix1 afix2  )
     ( Runtime: lim start --  ; begin loop )
   R<>D PUSH_CX R<>D   ( Store CX=counter )
   MOV_CX,BX POP_BX
   R<>D PUSH_BX R<>D POP_BX ( Init counter and limit )
   0 T_LIT HERE ( Jumpback addr ) ; IMMEDIATE
: ?DO ( Compile: -- afix1 afix2 )
      ( Runtime: lim start --  ; begin loop )
   R<>D PUSH_CX R<>D ( Store CX=counter )
   MOV_CX,BX POP_BX MOV_DX,BX
   R<>D PUSH_BX R<>D POP_BX ( Init counter and limit )
   CMP_CX,DX JL 3 T_LIT C, JMPFWD HERE ( Jumpback addr )
   ; IMMEDIATE
: LOOP ( Compile: afix1 afix2 --  ; End a loop construct )
       ( Runtime: -- )
   INC_CX 0 T_LIT MOV_DX,#[BP]
   CMP_CX,DX JGE 3 T_LIT C, JMP_#
   FIXFWD R<>D POP_CX POP_CX R<>D ; IMMEDIATE
: +LOOP ( Compile: afix1 afix2 --  ; End a loop construct )
        ( Runtime: n1 -- )
   ADD_CX,BX POP_BX 0 T_LIT MOV_DX,#[BP]
   CMP_CX,DX JGE 3 T_LIT C, JMP_#
   FIXFWD R<>D POP_CX POP_CX R<>D ; IMMEDIATE
: I         PUSH_BX         MOV_BX,CX ; IMMEDIATE
: J         PUSH_BX 2 T_LIT MOV_BX,#[BP] ; IMMEDIATE
: K         PUSH_BX 6 T_LIT MOV_BX,#[BP] ; IMMEDIATE

: >R        R<>D PUSH_BX R<>D POP_BX ; IMMEDIATE
: R>        PUSH_BX R<>D POP_BX R<>D ; IMMEDIATE
: R@        PUSH_BX 0 T_LIT MOV_BX,#[BP] ; IMMEDIATE

: 1+        STATE @ IF INC_BX        ELSE 1+ ENDIF ; IMMEDIATE
: 1-        STATE @ IF DEC_BX        ELSE 1- ENDIF ; IMMEDIATE
: 2+        STATE @ IF INC_BX INC_BX ELSE 2+ ENDIF ; IMMEDIATE
: 2-        STATE @ IF DEC_BX DEC_BX ELSE 2- ENDIF ; IMMEDIATE

: NEGATE    STATE @ IF NEG_BX        ELSE T_NEGATE ENDIF ; IMMEDIATE

: =
   STATE @ IF
      POP_AX SUB_BX,AX 1 T_LIT SUB_BX,# SBB_BX,BX
   ELSE = ENDIF ; IMMEDIATE
: 0=
   STATE @ IF
      1 T_LIT SUB_BX,# SBB_BX,BX
   ELSE 0= ENDIF ; IMMEDIATE
: <>
   STATE @ IF
      POP_AX SUB_BX,AX NEG_BX SBB_BX,BX
   ELSE <> ENDIF ; IMMEDIATE
: 0<>
   STATE @ IF
      NEG_BX SBB_BX,BX
   ELSE 0<> ENDIF ; IMMEDIATE
: <
   STATE @ IF
      POP_AX CMP_BX,AX 0 T_LIT MOV_BX,#
      JLE 1 T_LIT C, DEC_BX
   ELSE < ENDIF ; IMMEDIATE
: <=
   STATE @ IF
      POP_AX CMP_BX,AX 0 T_LIT MOV_BX,#
      JL  1 T_LIT C, DEC_BX
   ELSE <= ENDIF ; IMMEDIATE
: >
   STATE @ IF
      POP_AX CMP_BX,AX 0 T_LIT MOV_BX,#
      JGE 1 T_LIT C, DEC_BX
   ELSE > ENDIF ; IMMEDIATE
: >=
   STATE @ IF
      POP_AX CMP_BX,AX 0 T_LIT MOV_BX,#
      JG  1 T_LIT C, DEC_BX
   ELSE >= ENDIF ; IMMEDIATE
: AND
   STATE @ IF
      POP_AX AND_BX,AX
   ELSE AND ENDIF ; IMMEDIATE
( : NOT        T_SHL_BX,1 T_SBB_BX,BX ; IMMEDIATE
: OR
   STATE @ IF
      POP_AX OR_BX,AX
   ELSE OR ENDIF ; IMMEDIATE

: +
   STATE @ IF
      POP_AX ADD_BX,AX
   ELSE + ENDIF ; IMMEDIATE
: -
   STATE @ IF
      MOV_AX,BX POP_BX SUB_BX,AX
   ELSE - ENDIF ; IMMEDIATE
: *
   STATE @ IF
      MOV_AX,BX POP_BX MUL_BX MOV_BX,AX
   ELSE * ENDIF ; IMMEDIATE

: @
   STATE @ IF
      MOV_BX,[BX]
   ELSE @ ENDIF ; IMMEDIATE
: !
   STATE @ IF
      POP_AX MOV_[BX],AX POP_BX
   ELSE ! ENDIF ; IMMEDIATE
: +!
   STATE @ IF
      POP_AX ADD_[BX],AX POP_BX
   ELSE +! ENDIF ; IMMEDIATE
: C@
   STATE @ IF
      MOV_BL,[BX] 0 T_LIT MOV_BH,#
   ELSE C@ ENDIF ; IMMEDIATE
: C!
   STATE @ IF
      POP_AX MOV_[BX],AL POP_BX
   ELSE C! ENDIF ; IMMEDIATE

: DROP
   STATE @ IF
      POP_BX
   ELSE DROP ENDIF ; IMMEDIATE
: DUP
   STATE @ IF
      PUSH_BX
   ELSE DUP ENDIF ; IMMEDIATE
: NIP
   STATE @ IF
      POP_AX
   ELSE NIP ENDIF ; IMMEDIATE
: OVER
   STATE @ IF
      POP_AX PUSH_AX XCHG_AX,BX PUSH_AX
   ELSE OVER ENDIF ; IMMEDIATE
: SWAP
   STATE @ IF
      POP_AX XCHG_AX,BX PUSH_AX
   ELSE SWAP ENDIF ; IMMEDIATE
: CLR
   STATE @ IF
      0 T_LIT MOV_BX,#
   ELSE 0 T_MOV_BX,# ENDIF ; IMMEDIATE

: 2DROP
   STATE @ IF
      POP_BX POP_BX
   ELSE T_POP_BX T_POP_BX ENDIF ; IMMEDIATE
: 2DUP
   STATE @ IF
      POP_AX PUSH_AX PUSH_BX PUSH_AX
   ELSE 2DUP ENDIF ; IMMEDIATE
: 2SWAP ( n1 n2 n3 n4 -- n3 n4 n1 n2 )
   T_POP_AX T_SWITCH 2 T_XCHG_#[BP],AX
   0 T_XCHG_#[BP],BX T_SWITCH T_PUSH_AX ;


: EXECUTE
    T_MOV_AX,BX T_POP_BX T_SWITCH
    T_CALL_AX T_SWITCH ;

__( Building DEPTH )
: DEPTH ( -- n  ; Push stack depth )
  T_PUSH_BX 6 T_MOV_BX,# T_MOV_BX,[BX]
  T_MOV_AX,SP T_SUB_BX,AX T_SAR_BX,1 1- ;
