(
(
( 8086 MS-Dos target definitions
(
( 8086 Register use: )
(
( AX - tmp )
( BX - always Top Of Stack )
( CX - loop counter )
( DX - tmp )
( SI - ? )
( DI - ? )
( BP - Return stack pointer )
( SP - Data stack pointer )


HEX

__( Building 8086 crosscompile macro's )
ONLY FORTH ALSO DEFINITIONS

: TCELL
   0004 ;
: TC, ( c --  ; write char to kernelimage )
   KERNPOS @ C! 1 KERNPOS +! ;
: TS, ( n --  l write 16 bits to kernelimage )
   0100 U/MOD TC, TC, ;
: T,  ( n --  ; write integer to kernelimage )
   0 TC, 0 TC, TS, ;

: TIC,
   TC, ;
: TIS,
   TS, ;
: TSWITCH
   EC87 TIS, ;
: TRET
   00C3 TIC, ;

: THEADER
   0000 T, 0000 TC,  ( link + type )
   0020 WORD DUP C@ 1+ 0 DO DUP @ TC, 1+ LOOP DROP ;

__( Building crosscompiler )
ONLY FORTH ALSO CROSS DEFINITIONS

: VARIABLE
   THEADER
   0000 T, 0000 T, ( value ) ;

: CONSTANT
   THEADER
   0000 T, T, ( value ) ;

: :
  THEADER TSWITCH ;
: ;
  TSWITCH TRET ;

