
		MODEL	SMALL

		.CODE
		.8086
		org	0100h,0h


_DUP		EQU	010h
_DROP		EQU	011h
_SWAP		EQU	012h

_LIT		EQU	020h
_GET32		EQU	021h
_PUT32		EQU	022h
_GET8		EQU	023h
_PUT8		EQU	024h

_INC1		EQU	030h

_ADD		EQU	040h
_SUB		EQU	041h
_MUL		EQU	042h


_GET_DSP	EQU	070h
_GET_RSP	EQU	071h

_PUT_DSP	EQU	074h
_PUT_RSP	EQU	075h

_JMPTOS		EQU	078h
_JMPIMM		EQU	079h
_JSRTOS		EQU	07Ah
_JSRIMM		EQU	07Bh

_RETURN		EQU	07Fh

_OPENFILE	EQU	080h
_READFILE	EQU	081h
_WRITEFILE	EQU	082h
_CLOSEFILE	EQU	083h


START:

		dw	OFFSET INITSYS-0100h,0
_BOOTADDR	dw	OFFSET BOOT-0100h,0
_ORG_DSP	dd	0
_ORG_RSP	dd	0


_TYPE:
		db	_LIT
		dd	1
		db	_WRITEFILE
		db	_RETURN

_TYPES:
		db	_DUP
		db	_INC1
		db	_SWAP
		db	_GET8
		db	_JMPIMM
		dw	OFFSET _TYPE-0100h,0

_QUIT:
		db	_RETURN

BOOT:
		db	_LIT
		dw	OFFSET BOOTMSG-0100h,0
		db	_JSRIMM
		dw	OFFSET _TYPES-0100h,0
		db	_JSRIMM
		dw	OFFSET _QUIT-0100h,0
		db	2

BOOTMSG		db	44,"MPForth 0.9.799-VM  Copyright PW.Soft. 1999."


INITSYS:
		db	_GET_DSP
		db	_LIT
		dw	OFFSET _ORG_DSP-0100h,0
		db	_PUT32
		
		db	_GET_RSP
		db	_LIT
		dw	OFFSET _ORG_RSP-0100h,0
		db	_PUT32
		
		db	_LIT
		dw	OFFSET _BOOTADDR-0100h,0
		db	_GET32
		db	_JMPTOS


		END	START
