
DECIMAL

: VIDEOMODE ( mode --  ; Set new video mode )
   R<>D PUSH_CX R<>D
   [ 0 ] MOV_BH,# MOV_AX,BX [ 16 ] INT_# POP_BX
   R<>D POP_CX R<>D ;

: TEXTMODE ( --  ; Restore text mode )
   3 VIDEOMODE ;

: PIXEL ( y x color --  ; Plot pixel )
   R<>D PUSH_CX R<>D
   [ 12 ] MOV_BH,# MOV_AX,BX [ 0 ] MOV_BX,#
   POP_CX POP_DX [ 16 ] INT_# POP_BX 
   R<>D POP_CX R<>D ;

: FPIXEL ( y x color --  ; Fast plot pixel )
   ;

: DEMO
   17 VIDEOMODE
   480 0 DO
      640 0 DO J I 15 PIXEL LOOP
   LOOP
   KEY TEXTMODE
   ;

: 10/ ( n -- n/10)
   10 U/MOD NIP ;

VARIABLE YA  0 YA !
VARIABLE YB  0 YB !
VARIABLE YS
VARIABLE Y1  0 Y1 !
VARIABLE Y2  0 Y2 !
VARIABLE Y3  0 Y3 !
: FILTER
   17 VIDEOMODE
   6400 0 DO
      YA @  2 + DUP 200 > IF CLR ENDIF YA !
      YB @  1 + DUP 200 > IF CLR ENDIF YB !

      YA @ YB @ + YS !

      YS @ I 10/ 15 PIXEL
      YS @ Y3 @ - I 10/ 15 PIXEL

      ( shift reg )
      Y2 @ Y3 !
      Y1 @ Y2 !
      YS @ Y1 !
   LOOP
   KEY TEXTMODE ;


VARIABLE GTX 0 GTX !
VARIABLE GTY 0 GTY !


: PGTEXT ( chr )
   32 - 5 *
   C" 0000022202000005757576737512450000024000" 1+ +
   5 0 DO
      DUP C@
      DUP 1 AND 0<> IF GTY @ I + GTX @ 2 + 15 PIXEL ENDIF
      DUP 2 AND 0<> IF GTY @ I + GTX @ 1 + 15 PIXEL ENDIF
          4 AND 0<> IF GTY @ I + GTX @     15 PIXEL ENDIF
      1+
   LOOP DROP
   ;

: GTEXT ( str len --  ; Plot graphics text )
   ( 13 ) 17 VIDEOMODE
   0 DO DUP C@ PGTEXT 4 GTX +! 1+ LOOP DROP
   0 GTX ! 6 GTY +!
   KEY DROP TEXTMODE ;

: GTEST
   C" !#!#$%&'" COUNT GTEXT ;
