
VARIABLE HOLDLOC
VARIABLE HOLD#

HEX

: VOCABULARY ( --  ; Create new vocabulary )
   ROOTVOC @ DEFVOC !
   CREATE 0 , DOES> CURVOC ! ;

: MU/MOD
   >R 0 R@ UM/MOD R> SWAP >R UM/MOD R> ;

: HOLD ( char --  ; store char at tmp conv buffer )
   HOLDLOC DUP -ROT ( -- pad char pad )
   @ C! 0 1 - SWAP +!
   1 HOLD# +! ;

: <# ( --  ; start numeric conversion )
   PAD HOLDLOC ! 0 HOLD# ! ;

: # ( d1 -- d2  ; convert single digit )
   BASE @ MU/MOD ROT 9 OVER < IF 7 + ENDIF ASCII 0 + HOLD ;

: #> ( -- str  ; end numeric conversion )
   HOLDLOC @ DUP HOLD# @ SWAP C! ;

: #S ( d1 --  ; convert number to digits )
   BEGIN # 2DUP OR 0= UNTIL 2DROP ;

: (SIGN ( n -- sign abs )
   DUP 0 < BASE @ 000A = AND IF NEGATE 65535 ELSE 0 ENDIF SWAP ;

: U. ( un --  ; display unsigned number on console )
   0000 <# #S #> TYPES 0020 EMIT ;

: . ( n --  ; display number on console )
   (SIGN 0000 <# #S IF ASCII - HOLD ENDIF #> TYPES 0020 EMIT ;

: ." ASCII " WORD ;


VARIABLE TOTALWORDS
: WORDS ( --  ; Display all known words )
   0 TOTALWORDS !
   0 CR USEVOC @ DUP 0<> IF
      BEGIN @
         DUP 0<> WHILE
         DUP 2+ C@ 0080 AND 0= IF
            1 TOTALWORDS +!
            SWAP ( -- def cnt )
            OVER 3 + DUP C@ ROT + ( -- def def+3 cnt )
            DUP 0046 ( =70 ) >= IF CR DROP DUP C@ ENDIF ( cursor pos >70? )
            1+ ( count space ) -ROT TYPES 0020 EMIT
         ENDIF
      REPEAT
   ENDIF CR DROP DROP
   C" Total=" TYPES TOTALWORDS @ . ;

DECIMAL

: FYI
   C" Free memory " TYPES IMMSTART @ HERE - U. CR
   ;

